<link rel="import" href="../polymer/polymer-element.html" />

<dom-module id="my-event-notifier">
    <template>
        <style>
            :host {
                display: block;
            }
        </style>
        <h2>Eventos y notifs</h2>
        <fieldset>
            <form>
                <legend>Formulario</legend>
                <p>
                    <label for="myinput"></label>
                    <input
                        type="text"
                        name="myinput"
                        id="myinput"
                        value="{{valorEscrito::input}}"
                        placeholder="[[placeHolder]]"
                        required="[[required]]"
                    />
                </p>
                <button type="submit">Enviar form</button>
            </form>
        </fieldset>
        <hr />
        <span>Valor ingresado [[valorEscrito]]</span>
    </template>

    <script>
        /**
         * `my-event-notifier`
         * notify
         *
         * @customElement
         * @polymer
         * @demo demo/index.html
         */
        class MyEventNotifier extends Polymer.Element {
            static get is() {
                return "my-event-notifier";
            }
            static get properties() {
                return {
                    texto: {
                        type: String,
                    },
                    valorEscrito: {
                        type: String,
                        notify: true,
                    },
                    placeHolder: {
                        type: String,
                        value: "Valor aqui",
                    },
                    required: {
                        type: Boolean,
                    },
                };
            }

            ready() {
                super.ready();
                this.addEventListener("valor-escrito-changed", (e) => {
                    console.log("Evento lanzado");
                    console.log(e);
                });
            }
        }

        window.customElements.define(MyEventNotifier.is, MyEventNotifier);
    </script>
</dom-module>
